;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite A9 - Reznor
; commented by yoshicookiezeus
;
; NOTE: The palette of the sprite is hardcoded inside the ASM file. To change it, look
; for the "ReznorPal" table. As always, the entries are in the YXCCPPPT format.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


			!RAM_FrameCounter	= $13
			!RAM_FrameCounterB	= $14
			!RAM_MarioDirection	= $76
			!RAM_MarioSpeedX	= $7B
			!RAM_MarioSpeedY	= $7D
			!RAM_MarioXPos		= $94
			!RAM_MarioXPosHi	= $95
			!RAM_MarioYPos		= $96
			!RAM_SpritesLocked	= $9D
			!RAM_SpriteNum		= $9E
			!RAM_SpriteSpeedY	= $AA
			!RAM_SpriteSpeedX	= $B6
			!RAM_SpriteState	= $C2
			!RAM_SpriteYLo		= $D8
			!RAM_SpriteXLo		= $E4
			!OAM_DispX		= $0300
			!OAM_DispY		= $0301
			!OAM_Tile		= $0302
			!OAM_Prop		= $0303
			!OAM_Tile2DispX		= $0304
			!OAM_Tile2DispY		= $0305
			!OAM_Tile2		= $0306
			!OAM_Tile2Prop		= $0307
			!OAM_TileSize		= $0460
			!RAM_RandomByte1	= $148D
			!RAM_RandomByte2	= $148E
			!RAM_KickImgTimer	= $149A
			!RAM_SpriteYHi		= $14D4
			!RAM_SpriteXHi		= $14E0
			!RAM_Reznor1Dead	= $1520
			!RAM_Reznor2Dead	= $1521
			!RAM_Reznor3Dead	= $1522
			!RAM_Reznor4Dead	= $1523
			!RAM_DisableInter	= $154C
			!RAM_SpriteDir		= $157C
			!RAM_SprObjStatus	= $1588
			!RAM_OffscreenHorz	= $15A0
			!RAM_SprOAMIndex	= $15EA
			!RAM_SpritePal		= $15F6
			!RAM_Tweaker1662	= $1662
			!RAM_ExSpriteNum	= $170B
			!RAM_ExSpriteYLo	= $1715
			!RAM_ExSpriteXLo	= $171F
			!RAM_ExSpriteYHi	= $1729
			!RAM_ExSpriteXHi	= $1733
			!RAM_ExSprSpeedY	= $173D
			!RAM_ExSprSpeedX	= $1747
			!RAM_OffscreenVert	= $186C
			!RAM_OnYoshi		= $187A

			!RAM_ExtraBits 		= $7FAB10
			!RAM_NewSpriteNum	= $7FAB9E

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

			print "INIT ",pc
			CPX #$07			;\ if sprite index not equal to seven,
			BNE CODE_03987E			;/ branch
			LDA #$04
			STA !RAM_SpriteState,x
			JSL $03DD7D
CODE_03987E:		JSL $01ACF9			;\ set ??? to random number
			STA $1570,x			;/
			RTL				; return


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite code JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

			print "MAIN ",pc
			PHB
			PHK
			PLB
			JSR ReznorMain
			PLB
			RTL


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ReznorStartPosLo:	db $00,$80,$00,$80

ReznorStartPosHi:	db $00,$00,$01,$01

ReboundSpeedX:		db $20,$E0


ReznorMain:		INC $140F			; increase some sort of timer
			LDA !RAM_SpritesLocked		;\ if sprites not locked,
			BEQ ReznorNotLocked		;/ branch
			JMP DrawReznor

ReznorNotLocked:	CPX #$07			;\ if sprite index not equal to 7,
			BNE CODE_039910			;/ branch
			PHX				; preserve sprite index
			JSL $03D70C			; call the bridge breaking routine

ReznorSignCode:		LDA #$80			;\ set center of rotation for Reznor sign
			STA $2A				; |
			STZ $2B				;/
			LDX #$00
			LDA #$C0			;\ set x position of Reznor sign
			STA !RAM_SpriteXLo		; |
			STZ !RAM_SpriteXHi		;/
			LDA #$B2			;\ set y position of Reznor sign
			STA !RAM_SpriteYLo		; |
			STZ !RAM_SpriteYHi		;/

			LDA #$2C			;\ unknown
			STA $1BA2			;/
              
			JSL $03DEDF			; apply sign position changes

			PLX				; retrieve sprite index

			REP #$20			; set 16-bit accumulator mode
			LDA $36				;\ rotate sign one frame clockwise
			CLC				; |
			ADC #$0001			; |
			AND #$01FF			; |
			STA $36				;/
			SEP #$20			; set 8-bit accumulator mode

			CPX #$07			;\ if sprite index not equal to 7,
			BNE CODE_039910			;/ branch

			LDA $163E,x			;\ if level end timer not set,
			BEQ ReznorNoLevelEnd		;/ branch
			DEC A				;\ if not time to end level,
			BNE CODE_039910			;/ branch
			DEC $13C6			; make Mario freeze at level end
			LDA #$FF			;\ set time before return to overworld 
			STA $1493			;/
			LDA #$0B			;\ play sound effect
			STA $1DFB			;/
			RTS				; return

ReznorNoLevelEnd:	LDA !RAM_Reznor4Dead		;\ if all Reznors not dead,
			CLC				; |
			ADC !RAM_Reznor3Dead		; |
			ADC !RAM_Reznor2Dead		; |
			ADC !RAM_Reznor1Dead		; |
			CMP #$04			; |
			BNE CODE_039910			;/ branch
			LDA #$90			;\ set level end timer
			STA $163E,x			;/
			JSL $03A6C8			; kill normal sprites
			LDY #$07			;\ clear extended sprite tables
CODE_03990A:		LDA #$00			; |
			STA !RAM_ExSpriteNum,y		; |
			DEY				; |
			BPL CODE_03990A			;/

CODE_039910:		LDA $14C8,x			;\ if sprite state is normal,
			CMP #$08			; |
			BEQ CODE_03991A			;/ branch to sprite main code
CODE_039917:		JMP DrawReznor

CODE_03991A:		TXA				;\ get Reznor number into y register
			AND #$03			; |
			TAY				;/
								  
			LDA $36				;\ get Reznor's position on the circle into $00-$01
			CLC				; |
			ADC ReznorStartPosLo,y		; |
			STA $00				; |
			LDA $37				; |
			ADC ReznorStartPosHi,y		; |
			AND #$01			; |
			STA $01				;/

			REP #$30			; set 16-bit mode for accumulator and registers 
			LDA $00				;\ $00-$01 = Reznor angle
			EOR #$01FF			; |
			INC A				; |
			STA $00				;/
			CLC				;\ $02-$03 = Reznor angle + a right angle
			ADC #$0080			; |
			AND #$01FF			; |
			STA $02				;/

			LDA $00				;\ $04-$05 = cosines for Reznor angle
			AND #$00FF			; |
			ASL				; |
			TAX				; |
			LDA $07F7DB,x			; | trig table
			STA $04				;/
			LDA $02				;\ $06-$07 = sines for Reznor angle
			AND #$00FF			; |
			ASL				; |
			TAX				; |
			LDA $07F7DB,x			; |
			STA $06				;/
			SEP #$30			; set 8-bit mode for accumulators and registers

			LDA $04				;\ multiply $04...
			STA $4202			; |
			LDA #$38			; |
			LDY $05				; |\ if $05 is 1, no need to do the multiplication
			BNE CODE_039978			; |/ 
			STA $4203			;/ by radius of circle (#$38)
			NOP				;\ wait for result
			NOP				; |
			NOP				; |
			NOP				;/
			ASL $4216			; Product/Remainder Result (Low Byte)
			LDA $4217			; Product/Remainder Result (High Byte)
			ADC #$00
CODE_039978:		LSR $01
			BCC CODE_03997F
			EOR #$FF
			INC A
CODE_03997F:		STA $04

			LDA $06				;\ multiply $06...
			STA $4202			; |
			LDA #$38			; |
			LDY $07				; |\ if $07 is 1, no need to do the multiplication
			BNE CODE_03999B			; |/
			STA $4203			;/ with radius of circle
			NOP				;\ wait for result
			NOP				; |
			NOP				; |
			NOP				;/
			ASL $4216			; Product/Remainder Result (Low Byte)
			LDA $4217			; Product/Remainder Result (High Byte)
			ADC #$00			
CODE_03999B:		LSR $03				
			BCC CODE_0399A2			
			EOR #$FF			
			INC A				
CODE_0399A2:		STA $06
				
			LDX $15E9			; get sprite index
			LDA !RAM_SpriteXLo,x		;\ preserve current sprite x position for later
			PHA				;/

			STZ $00				;\
			LDA $04				; | x offset low byte
			BPL CODE_0399B2			; |
			DEC $00				; |
CODE_0399B2:		CLC				; |
			ADC $2A				; | + x position of centerpoint of rotation low byte
			PHP				; |
			CLC				; |
			ADC #$40			; | + 40
			STA !RAM_SpriteXLo,x		;/  = sprite x position low byte

			LDA $2B				;\  x position of rotation high byte
			ADC #$00			; | + adjustment for screen boundaries
			PLP				; |
			ADC $00				; |
			STA !RAM_SpriteXHi,x		;/  = sprite x position high byte

			PLA				;\ $1528,x = current frame's movement on the x axis
			SEC 				; |
			SBC !RAM_SpriteXLo,x		; |
			EOR #$FF			; |
			INC A				; |
			STA $1528,X			;/

			STZ $01				;\
			LDA $06				; | y offset low byte
			BPL CODE_0399D7			; |
			DEC $01				; |
CODE_0399D7:		CLC				; |
			ADC $2C				; | + y position of centerpoint of rotation low byte
			PHP				; |
			ADC #$20			; | + 20
			STA !RAM_SpriteYLo,x		;/  = sprite y position low byte

			LDA $2D				;\  y position of rotation high byte
			ADC #$00			; | + adjustment for screen boundaries
			PLP				; |
			ADC $01				; |
			STA !RAM_SpriteYHi,x		;/  = sprite y position high byte

			LDA $151C,x			;\ if Reznor is alive,
			BEQ ReznorAlive			;/ branch 
			JSL $01B44F			; else, make platform solid
			JMP DrawReznor

ReznorAlive:		LDA !RAM_FrameCounter		;\ what
			AND #$00			;/
			ORA $15AC,x			;\ if turning,
			BNE NoSetRznrFireTime		;/ branch

			INC $1570,x			; increase firing timer
			LDA $1570,x			;\ if not time to spit fire,
			CMP #$00			; |
			BNE NoSetRznrFireTime		;/ branch
			STZ $1570,			;\ set time to show firing frame
			LDA #$40			; |
			STA $1558,x			;/

NoSetRznrFireTime:	TXA				;\ if not time to turn
			ASL				; |
			ASL 				; |
			ASL				; |
			ASL				; |
			ADC !RAM_FrameCounterB		; |
			AND #$3F			; |
			ORA $1558,x			; | or if firing
			ORA $15AC,x			; | or if already turning
			BNE NoSetRenrTurnTime		;/ branch

			LDA !RAM_SpriteDir,x		;\ make sprite face Mario
			PHA				; |
			JSR SUB_HORZ_POS		; |
			TYA				; |
			STA !RAM_SpriteDir,x		;/
			PLA				;\ if sprite didn't turn,
			CMP !RAM_SpriteDir,x		; |
			BEQ NoSetRenrTurnTime		;/ branch
			LDA #$0A			;\ set time to show turning frame
			STA $15AC,x			;/

NoSetRenrTurnTime:	LDA !RAM_DisableInter,x		;\ if interaction disabled,
			BNE DrawReznor			;/ branch
			JSL $01A7DC			; interact with Mario
			BCC DrawReznor			; if no contact, branch

			LDA #$08			;\ disable interaction for a short while
			STA !RAM_DisableInter,x		;/
			LDA !RAM_MarioYPos		;\ if Mario hit Reznor,
			SEC				; |
			SBC !RAM_SpriteYLo,x		; |
			CMP #$ED			; |
			BMI HitReznor			;/ branch

			CMP #$F2			;\ if Mario hit side of Reznor platform,
			BMI HitPlatSide			;/ branch
			LDA !RAM_MarioSpeedY		;\ if Mario is moving downwards,
			BPL HitPlatSide			;/ branch

HitPlatBottom:		LDA #$29			;\ set new sprite clipping size
			STA !RAM_Tweaker1662,x		;/
			LDA #$0F			;\ set platform bouncing timer
			STA $1564,x			;/
			LDA #$10			;\ set new Mario y speed
			STA !RAM_MarioSpeedY		;/
			LDA #$01			;\ play sound effect
			STA $1DF9			;/
			BRA DrawReznor

HitPlatSide:		JSR SUB_HORZ_POS		; check which side of platform Mario hit
			LDA ReboundSpeedX,y		;\ set new Mario x speed
			STA !RAM_MarioSpeedX		;/
			BRA DrawReznor

HitReznor:		JSL $00F5B7			; hurt Mario

DrawReznor:		STZ $1602,x			; set normal frame
			LDA !RAM_SpriteDir,x		;\ preserve sprite direction
			PHA				;/
			LDY $15AC,x			;\ if Reznor isn't turning,
			BEQ ReznorNoTurning		;/ branch
			CPY #$05			;\ if time to turn,
			BCC ReznorTurning		;/ branch
			EOR #$01			;\ reverse sprite direction
			STA !RAM_SpriteDir,x		;/
ReznorTurning:		LDA #$02			;\ set turning frame
			STA $1602,x			;/

ReznorNoTurning:	LDA $1558,x			;\ if Reznor isn't firing,
			BEQ ReznorNoFiring		;/ branch
			CMP #$20			;\ if not time to shoot fireball,
			BNE ReznorFiring		;/ branch
			JSR ReznorFireRt
ReznorFiring:		LDA #$01			;\ set firing frame
			STA $1602,x			;/

ReznorNoFiring:		JSR ReznorGfxRt

			PLA				;\ restore sprite direction
			STA !RAM_SpriteDir,x		;/
			LDA !RAM_SpritesLocked		;\ if sprites locked
			ORA $151C,x			; | or if Reznor killed,
			BNE Return039AF7		;/ branch
			LDA $1564,x			;\ if not time to kill Reznor,
			CMP #$0C			; |
			BNE Return039AF7		;/ branch

KillReznor:		LDA #$03			;\ play sound effect
			STA $1DF9			;/
			STZ $1558,x			; clear firing timer
			INC $151C,x			; mark Reznor as dead
			JSL $02A9E4			; find free sprite slot for dead Reznor
			BMI Return039AF7		; if no free slots, branch

			LDA #$02			;\ set sprite status of new sprite (killed)
			STA $14C8,y			;/
			LDA !RAM_NewSpriteNum,x		;\ set sprite number of new sprite (Reznor)
			PHX				; |
			TYX				; |
			STA !RAM_NewSpriteNum,x		; |
			PLX				;/
			LDA !RAM_SpriteXLo,x		;\ set x position of new sprite
			STA $00E4,y			; |
			LDA !RAM_SpriteXHi,x		; |
			STA !RAM_SpriteXHi,y		;/
			LDA !RAM_SpriteYLo,x		;\ set y position of new sprite
			STA $00D8,y			; |
			LDA !RAM_SpriteYHi,x		; |
			STA !RAM_SpriteYHi,y		;/

			PHX				; preserve sprite index
			TYX				;\ clear out sprite tables for new sprite
			JSL $07F7D2			;/
			JSL $0187A7			; get table values for custom sprite
			LDA #$88			;\ mark sprite as initialized
			STA !RAM_ExtraBits,x		;/
			LDA #$C0			;\ set y speed for new sprite
			STA !RAM_SpriteSpeedY,x		;/
			PLX				; retrieve sprite index

Return039AF7:		RTS				; return

ReznorFireRt:		LDY #$07			;\ find free slot for extended sprite
CODE_039AFA:		LDA !RAM_ExSpriteNum,y		; |
			BEQ FoundRznrFireSlot		; |
			DEY				; |
			BPL CODE_039AFA			;/
			RTS				; if no free slots, return

FoundRznrFireSlot:	LDA #$10			;\ play sound effect
			STA $1DF9			;/
			LDA #$02			;\ set sprite number of new extended sprite (Reznor fireball
			STA !RAM_ExSpriteNum,y		;/
			LDA !RAM_SpriteXLo,x		;\ preserve sprite x position
			PHA				;/
			SEC				;\ set x position of new extended sprite
			SBC #$08			; |
			STA !RAM_ExSpriteXLo,y		; |
			STA !RAM_SpriteXLo,x		; |
			LDA !RAM_SpriteXHi,x		; |
			SBC #$00			; |
			STA !RAM_ExSpriteXHi,y		;/
			LDA !RAM_SpriteYLo,x		;\ preserve sprite y position
			PHA				;/
			SEC				;\ set y position of new extended sprite
			SBC #$14			; |
			STA !RAM_SpriteYLo,x		; |
			STA !RAM_ExSpriteYLo,y		; |
			LDA !RAM_SpriteYHi,x		; |
			PHA				; |
			SBC #$00			; |                
			STA !RAM_ExSpriteYHi,y		;/
			STA !RAM_SpriteYHi,x		;
			LDA #$10			;\ aiming routine
			JSR CODE_0397F9			;/ gets needed y speed into $00 and x speed into $01
			PLA				;\ restore sprite position
			STA !RAM_SpriteYHi,x		; |
			PLA				; |                       
			STA !RAM_SpriteYLo,x		; |
			PLA				; |
			STA !RAM_SpriteXLo,x		;/
			LDA $00				;\ set new extended sprite y speed
			STA !RAM_ExSprSpeedY,y		;/
			LDA $01				;\ set new extended sprite x speed
			STA !RAM_ExSprSpeedX,y		;/
			RTS				; return


ReznorTileDispX:	db $00,$F0,$00,$F0,$F0,$00,$F0,$00
ReznorTileDispY:	db $E0,$E0,$F0,$F0

ReznorTiles:		db $40,$42,$60,$62,$44,$46,$64,$66
			db $28,$28,$48,$48

ReznorPal:		db $3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F
			db $7F,$3F,$7F,$3F

ReznorGfxRt:		LDA $151C,x			;\ if Reznor is dead,
			BNE DrawReznorPlats		;/ branch

			JSR GET_DRAW_INFO
			LDA $1602,x			;\ $03 = frame index
			ASL				; |
			ASL				; |
			STA $03				;/
			LDA !RAM_SpriteDir,x		;\ $02 = direction index
			ASL				; |
			ASL				; |
			STA $02				;/

			PHX				; preserve sprite index
			LDX #$03			; set number of tiles to draw

RznrGfxLoopStart:	PHX				; preserve tile index
			LDA $03				;\ if frame index is 8 (turning?),
			CMP #$08			; |
			BCS CODE_039B99			;/ branch
			TXA				;\ add in direction index
			ORA $02				; |
			TAX				;/

CODE_039B99:		LDA $00				;\ set tile x position
			CLC				; |
			ADC ReznorTileDispX,x		; |
			STA !OAM_DispX,y		;/

			PLX				; retrieve tile index
			LDA $01				;\ set tile y position
			CLC				; |
			ADC ReznorTileDispY,x		; |
			STA !OAM_DispY,y		;/

			PHX				; preserve tile index
			TXA				;\ add in direction index
			ORA $03				; |
			TAX				;/
			LDA ReznorTiles,x		;\ set tile number
			STA !OAM_Tile,y			;/
			LDA ReznorPal,x			;\ set tile properties
			CPX #$08			; | if turning,
			BCS NoReznorGfxFlip		; | branch
			LDX $02				; | if direction = 0,
			BNE NoReznorGfxFlip		; | branch
			EOR #$40			; | flip tile horizontally
NoReznorGfxFlip:	STA !OAM_Prop,y			;/

			PLX				; retrieve tile index
			INY				;\ increase OAM index by four
			INY				; |
			INY				; |
			INY				;/
			DEX				;\ if frames left to draw,
			BPL RznrGfxLoopStart		;/ branch

			PLX				; retrieve sprite number

			LDY #$02			; the tiles written were 16x16
			LDA #$03			; we wrote four tiles
			JSL $01B7B3			; finish OAM write

			LDA $14C8,x			;\ if Reznor dead and falling from platform,
			CMP #$02			; |
			BEQ Return039BE2		;/ branch
DrawReznorPlats:	JSR ReznorPlatGfxRt
Return039BE2:		RTS				; return


ReznorPlatDispY:	db $00,$03,$04,$05,$05,$04,$03,$00

ReznorPlatGfxRt:	LDA !RAM_SprOAMIndex,x		;\ get new sprite OAM index
			CLC				; |
			ADC #$10			; |
			STA !RAM_SprOAMIndex,x		;/
			JSR GET_DRAW_INFO

			LDA $1564,x			;\ $02 = platform y offset from bouncing
			LSR				; |
			PHY				; |                       
			TAY				; |
			LDA ReznorPlatDispY,y		; |
			STA $02				; |
			PLY				;/

			LDA $00				;\ set tiles x position
			STA !OAM_Tile2DispX,y		; |
			SEC				; |
			SBC #$10			; |
			STA !OAM_DispX,y		;/
			LDA $01				;\ set tiles y position
			SEC				; |
			SBC $02				; |
			STA !OAM_DispY,y		; |
			STA !OAM_Tile2DispY,y		;/
			LDA #$4E			;\ set tiles number
			STA !OAM_Tile,y			; |
			STA !OAM_Tile2,y		;/
			LDA #$33			;\ set tiles properties
			STA !OAM_Prop,y			; |
			ORA #$40			; | right tile should be flipped
			STA !OAM_Tile2Prop,y		;/

			LDY #$02			; the tiles written were 16x16
			LDA #$01			; we wrote two tiles
			JSL $01B7B3			; finish OAM write
			RTS				; return


CODE_0397F9:		STA $01				; aiming routine
			PHX				; outputs y speed into $00 and x speed into $01
			PHY				; similar to the one used by Magikoopa
			JSR SUB_VERT_POS
			STY $02
			LDA $0E
			BPL CODE_03980B
			EOR #$FF
			CLC
			ADC #$01
CODE_03980B:		STA $0C
			JSR SUB_HORZ_POS
			STY $03
			LDA $0F
			BPL CODE_03981B
			EOR #$FF
			CLC
			ADC #$01
CODE_03981B:		STA $0D
			LDY #$00
			LDA $0D
			CMP $0C
			BCS CODE_03982E
			INY
			PHA
			LDA $0C
			STA $0D
			PLA
			STA $0C
CODE_03982E:		LDA #$00
			STA $0B
			STA $00
			LDX $01
CODE_039836:		LDA $0B
			CLC
			ADC $0C
			CMP $0D
			BCC CODE_039843
			SBC $0D
			INC $00
CODE_039843:		STA $0B
			DEX
			BNE CODE_039836
			TYA
			BEQ CODE_039855
			LDA $00
			PHA
			LDA $01
			STA $00
			PLA
			STA $01
CODE_039855:		LDA $00
			LDY $02
			BEQ CODE_039862
			EOR #$FF
			CLC
			ADC #$01
			STA $00
CODE_039862:		LDA $01
			LDY $03
			BEQ CODE_03986F
			EOR #$FF
			CLC
			ADC #$01
			STA $01
CODE_03986F:		PLY
			PLX
			RTS


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;org $03B75C

TABLE1:			db $0C,$1C
TABLE2:			db $01,$02

GET_DRAW_INFO:		STZ $186C,x             ; reset sprite offscreen flag, vertical
			STZ $15A0,x             ; reset sprite offscreen flag, horizontal
			LDA $E4,x               ; \
			CMP $1A                 ;  | set horizontal offscreen if necessary
			LDA $14E0,x             ;  |
			SBC $1B                 ;  |
			BEQ ON_SCREEN_X         ;  |
			INC $15A0,x             ; /

ON_SCREEN_X:		LDA $14E0,x             ; \
			XBA			;  |
			LDA $E4,x               ;  |
			REP #$20                ;  |
			SEC			;  |
			SBC $1A                 ;  | mark sprite invalid if far enough off screen
			CLC			;  |
			ADC #$0040            ;  |
			CMP #$0180            ;  |
			SEP #$20                ;  |
			ROL A                   ;  |
			AND #$01                ;  |
			STA $15C4,x             ; / 
			BNE INVALID             ; 
			
			LDY #$00                ; \ set up loop:
			LDA $1662,x             ;  | 
			AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
			BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
			INY			; / 
ON_SCREEN_LOOP:		LDA $D8,x               ; \ 
			CLC			;  | set vertical offscreen if necessary
			ADC TABLE1,y            ;  |
			PHP			;  |
			CMP $1C                 ;  | (vert screen boundry)
			ROL $00                 ;  |
			PLP			;  |
			LDA $14D4,x             ;  | 
			ADC #$00                ;  |
			LSR $00                 ;  |
			SBC $1D                 ;  |
			BEQ ON_SCREEN_Y         ;  |
			LDA $186C,x             ;  | (vert offscreen)
			ORA TABLE2,y            ;  |
			STA $186C,x             ;  |
ON_SCREEN_Y:		DEY			;  |
			BPL ON_SCREEN_LOOP      ; /

			LDY $15EA,x             ; get offset to sprite OAM
			LDA $E4,x               ; \ 
			SEC			;  | 
			SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
			STA $00                 ; / 
			LDA $D8,x               ; \ 
			SEC			;  | 
			SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
			STA $01                 ; / 
			RTS			; return

INVALID:		PLA			; \ return from *main gfx routine* subroutine...
			PLA			;  |    ...(not just this subroutine)
			RTS			; /

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SUB_OFF_SCREEN
; This subroutine deals with sprites that have moved off screen
; It is adapted from the subroutine at $01AC0D
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
			
SPR_T12:		db $40,$B0
SPR_T13:		db $01,$FF
SPR_T14:		db $30,$C0,$A0,$C0,$A0,$F0,$60,$90		;bank 1 sizes
			db $30,$C0,$A0,$80,$A0,$40,$60,$B0		;bank 3 sizes
SPR_T15:		db $01,$FF,$01,$FF,$01,$FF,$01,$FF		;bank 1 sizes
			db $01,$FF,$01,$FF,$01,$00,$01,$FF		;bank 3 sizes

SUB_OFF_SCREEN_X1:	LDA #$02                ; \ entry point of routine determines value of $03
			BRA STORE_03            ;  | (table entry to use on horizontal levels)
SUB_OFF_SCREEN_X2:	LDA #$04                ;  | 
			BRA STORE_03            ;  |
SUB_OFF_SCREEN_X3:	LDA #$06                ;  |
			BRA STORE_03            ;  |
SUB_OFF_SCREEN_X4:	LDA #$08                ;  |
			BRA STORE_03            ;  |
SUB_OFF_SCREEN_X5:	LDA #$0A                ;  |
			BRA STORE_03            ;  |
SUB_OFF_SCREEN_X6:	LDA #$0C                ;  |
			BRA STORE_03            ;  |
SUB_OFF_SCREEN_X7:	LDA #$0E                ;  |
STORE_03:		STA $03			;  |            
			BRA START_SUB		;  |
SUB_OFF_SCREEN_X0:	STZ $03			; /

START_SUB:		JSR SUB_IS_OFF_SCREEN   ; \ if sprite is not off screen, return
			BEQ RETURN_35           ; /
			LDA $5B                 ; \  goto VERTICAL_LEVEL if vertical level
			AND #$01                ; |
			BNE VERTICAL_LEVEL      ; /     
			LDA $D8,x               ; \
			CLC			; | 
			ADC #$50                ; | if the sprite has gone off the bottom of the level...
			LDA $14D4,x             ; | (if adding 0x50 to the sprite y position would make the high byte >= 2)
			ADC #$00                ; | 
			CMP #$02                ; | 
			BPL ERASE_SPRITE        ; /    ...erase the sprite
			LDA $167A,x             ; \ if "process offscreen" flag is set, return
			AND #$04                ; |
			BNE RETURN_35           ; /
			LDA $13                 ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZcHC:0756 VC:176 00 FL:205
			AND #$01                ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0780 VC:176 00 FL:205
			ORA $03                 ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0796 VC:176 00 FL:205
			STA $01                 ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0820 VC:176 00 FL:205
			TAY			;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0844 VC:176 00 FL:205
			LDA $1A                 ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0858 VC:176 00 FL:205
			CLC			;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZcHC:0882 VC:176 00 FL:205
			ADC SPR_T14,y           ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZcHC:0896 VC:176 00 FL:205
			ROL $00                 ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizcHC:0928 VC:176 00 FL:205
			CMP $E4,x               ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizCHC:0966 VC:176 00 FL:205
			PHP			;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:0996 VC:176 00 FL:205
			LDA $1B                 ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F0 P:envMXdizCHC:1018 VC:176 00 FL:205
			LSR $00                 ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F0 P:envMXdiZCHC:1042 VC:176 00 FL:205
			ADC SPR_T15,y           ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F0 P:envMXdizcHC:1080 VC:176 00 FL:205
			PLP			;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F0 P:eNvMXdizcHC:1112 VC:176 00 FL:205
			SBC $14E0,x             ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1140 VC:176 00 FL:205
			STA $00                 ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizCHC:1172 VC:176 00 FL:205
			LSR $01                 ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizCHC:1196 VC:176 00 FL:205
			BCC SPR_L31             ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZCHC:1234 VC:176 00 FL:205
			EOR #$80                ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZCHC:1250 VC:176 00 FL:205
			STA $00                 ;A:8A7F X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1266 VC:176 00 FL:205
SPR_L31:		LDA $00                 ;A:8A7F X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1290 VC:176 00 FL:205
			BPL RETURN_35           ;A:8A7F X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1314 VC:176 00 FL:205
ERASE_SPRITE:		LDA $14C8,x             ; \ if sprite status < 8, permanently erase sprite
			CMP #$08                ; |
			BCC KILL_SPRITE         ; /    
			LDY $161A,x             ;A:FF08 X:0007 Y:0001 D:0000 DB:01 S:01F3 P:envMXdiZCHC:1108 VC:059 00 FL:2878
			CPY #$FF                ;A:FF08 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdiZCHC:1140 VC:059 00 FL:2878
			BEQ KILL_SPRITE         ;A:FF08 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdizcHC:1156 VC:059 00 FL:2878
			LDA #$00                ;A:FF08 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdizcHC:1172 VC:059 00 FL:2878
			STA $1938,y             ;A:FF00 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdiZcHC:1188 VC:059 00 FL:2878
KILL_SPRITE:		STZ $14C8,x             ; erase sprite
RETURN_35:		RTS			 ; return

VERTICAL_LEVEL:		LDA $167A,x             ; \ if "process offscreen" flag is set, return
			AND #$04                ; |
			BNE RETURN_35           ; /
			LDA $13                 ; \
			LSR A                   ; | 
			BCS RETURN_35           ; /
			LDA $E4,x               ; \ 
			CMP #$00                ;  | if the sprite has gone off the side of the level...
			LDA $14E0,x             ;  |
			SBC #$00                ;  |
			CMP #$02                ;  |
			BCS ERASE_SPRITE        ; /  ...erase the sprite
			LDA $13                 ;A:0000 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:1218 VC:250 00 FL:5379
			LSR A                   ;A:0016 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1242 VC:250 00 FL:5379
			AND #$01                ;A:000B X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1256 VC:250 00 FL:5379
			STA $01                 ;A:0001 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1272 VC:250 00 FL:5379
			TAY			;A:0001 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1296 VC:250 00 FL:5379
			LDA $1C                 ;A:001A X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0052 VC:251 00 FL:5379
			CLC			;A:00BD X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0076 VC:251 00 FL:5379
			ADC SPR_T12,y           ;A:00BD X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0090 VC:251 00 FL:5379
			ROL $00                 ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F3 P:enVMXdizCHC:0122 VC:251 00 FL:5379
			CMP $D8,x               ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNVMXdizcHC:0160 VC:251 00 FL:5379
			PHP			;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNVMXdizcHC:0190 VC:251 00 FL:5379
			LDA $001D               ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F2 P:eNVMXdizcHC:0212 VC:251 00 FL:5379
			LSR $00                 ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F2 P:enVMXdiZcHC:0244 VC:251 00 FL:5379
			ADC SPR_T13,y           ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F2 P:enVMXdizCHC:0282 VC:251 00 FL:5379
			PLP			;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F2 P:envMXdiZCHC:0314 VC:251 00 FL:5379
			SBC $14D4,x             ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNVMXdizcHC:0342 VC:251 00 FL:5379
			STA $00                 ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0374 VC:251 00 FL:5379
			LDY $01                 ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0398 VC:251 00 FL:5379
			BEQ SPR_L38             ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0422 VC:251 00 FL:5379
			EOR #$80                ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0438 VC:251 00 FL:5379
			STA $00                 ;A:007F X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0454 VC:251 00 FL:5379
SPR_L38:		LDA $00                 ;A:007F X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0478 VC:251 00 FL:5379
			BPL RETURN_35           ;A:007F X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0502 VC:251 00 FL:5379
			BMI ERASE_SPRITE        ;A:8AFF X:0002 Y:0000 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0704 VC:184 00 FL:5490

SUB_IS_OFF_SCREEN:	LDA $15A0,x             ; \ if sprite is on screen, accumulator = 0 
			ORA $186C,x             ; |  
			RTS			; / return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B817 - horizontal mario/sprite check - shared
; Y = 1 if mario left of sprite??
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B817        

SUB_HORZ_POS:       LDY #$00                ;A:25D0 X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1020 VC:097 00 FL:31642
                    LDA $94                 ;A:25D0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZCHC:1036 VC:097 00 FL:31642
                    SEC                     ;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1060 VC:097 00 FL:31642
                    SBC $E4,x               ;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1074 VC:097 00 FL:31642
                    STA $0F                 ;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1104 VC:097 00 FL:31642
                    LDA $95                 ;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1128 VC:097 00 FL:31642
                    SBC $14E0,x             ;A:2500 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZcHC:1152 VC:097 00 FL:31642
                    BPL LABEL16             ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1184 VC:097 00 FL:31642
                    INY                     ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1200 VC:097 00 FL:31642
LABEL16:            RTS                     ;A:25FF X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizcHC:1214 VC:097 00 FL:31642




                    ;org $03B829        

SUB_VERT_POS:       LDY #$00                ;A:25D0 X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1020 VC:097 00 FL:31642
                    LDA $96                 ;A:25D0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZCHC:1036 VC:097 00 FL:31642
                    SEC                     ;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1060 VC:097 00 FL:31642
                    SBC $D8,x               ;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1074 VC:097 00 FL:31642
                    STA $0F                 ;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1104 VC:097 00 FL:31642
                    LDA $97                 ;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1128 VC:097 00 FL:31642
                    SBC $14D4,x             ;A:2500 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZcHC:1152 VC:097 00 FL:31642
                    BPL LABEL17             ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1184 VC:097 00 FL:31642
                    INY                     ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1200 VC:097 00 FL:31642
LABEL17:            RTS                     ;A:25FF X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizcHC:1214 VC:097 00 FL:31642